Index: clos.lisp
===================================================================
--- clos.lisp	(revision 14075)
+++ clos.lisp	(working copy)
@@ -1604,7 +1604,8 @@
 
 ;;; defgeneric
 
-(defmacro defgeneric (function-name lambda-list
+(defmacro defgeneric (&environment env
+                      function-name lambda-list
                                     &rest options-and-method-descriptions)
   (let ((options ())
         (methods ())
@@ -1622,9 +1623,10 @@
          (setf documentation t)
          (push item options))
         (:method
-         (push
-          `(push (defmethod ,function-name ,@(cdr item))
-                 (generic-function-initial-methods (fdefinition ',function-name)))
+         (push (let* ((tail (cdr (member-if #'listp item)))
+                      (preamble (ldiff item tail)))
+                 `(defmethod ,function-name ,@(cdr preamble)
+                    ,@(macroexpand-all tail env)))
           methods))
         (t
          (push item options))))
@@ -1637,12 +1639,11 @@
       (error 'program-error
              :format-control "&AUX is not allowed in a generic function lambda list: ~S"
              :format-arguments (list lambda-list)))
-    `(prog1
-       (%defgeneric
-        ',function-name
-        :lambda-list ',lambda-list
-        ,@(canonicalize-defgeneric-options options))
-       ,@methods)))
+    `(%defgeneric
+     ',function-name
+     ',methods
+     :lambda-list ',lambda-list
+     ,@(canonicalize-defgeneric-options options))))
 
 (defun canonicalize-defgeneric-options (options)
   (mapappend #'canonicalize-defgeneric-option options))
@@ -1699,7 +1700,7 @@
          (args2 (getf plist2 :required-args)))
     (= (length args1) (length args2))))
 
-(defun %defgeneric (function-name &rest all-keys)
+(defun %defgeneric (function-name methods &rest all-keys)
   (when (fboundp function-name)
     (let ((gf (fdefinition function-name)))
       (when (typep gf 'generic-function)
@@ -1715,7 +1716,11 @@
                                                       'remove-method method))))
               (remove-method gf method)))
         (setf (generic-function-initial-methods gf) '()))))
-  (apply 'ensure-generic-function function-name all-keys))
+  (let ((gf (apply 'ensure-generic-function function-name all-keys)))
+    (dolist (method methods)
+      (push (eval method)
+            (generic-function-initial-methods gf)))
+    gf))
 
 ;;; Bootstrap version of ensure-generic-function, handling only
 ;;; standard-generic-function.  This function is replaced later.
